const http = require('http');

// Define the hostname and port
var hostname = '0.0.0.0';
const port = 3000;
var latest_json = "";


// Create the HTTP server
const server = http.createServer((req, res) => {
    // Set CORS headers
    res.setHeader('Access-Control-Allow-Origin', '*');
    res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS');
    res.setHeader('Access-Control-Allow-Headers', 'Content-Type');

    // Handle preflight requests (OPTIONS)
    if (req.method === 'OPTIONS') {
        res.writeHead(200);
        res.end();
        return;
    }

    // Set the response HTTP header with Content type
    res.setHeader('Content-Type', 'text/plain');

    if (req.method === 'GET') {
        res.statusCode = 200;
        res.end(latest_json);
        latest_json = "";
    } else if (req.method === 'POST') {
        let body = '';

        // Listen for data
        req.on('data', chunk => {
            body += chunk.toString();
        });

        // Save received body to latest json variable
        req.on('end', () => {
            latest_json = decodeMessage(body);
            res.statusCode = 200;
            res.end('');
        });
    } else {
        res.statusCode = 405;
        res.end(`${req.method} is not supported\n`);
    }
});

// Listen for incoming requests
server.listen(port, hostname, () => {

    const os = require('os');
    const networkInterfaces = os.networkInterfaces();
    let serverIP = '';

    // Find the first non-internal IPv4 address
    for (const interfaceName in networkInterfaces) {
        const interface = networkInterfaces[interfaceName];
        for (const network of interface) {
            if (network.family === 'IPv4' && !network.internal) {
                serverIP = network.address;
                break;
            }
        }
        if (serverIP) break;
    }
    console.log(`Server running at http://${serverIP}:${port}/`);
    console.log(`Enter this URL in master mode server host URL settings`);
});

function decodeMessage(message) {
    // Check if the message is a Buffer
    if (Buffer.isBuffer(message)) {
        // Convert from binary to string
        return message.toString('utf8');
    } else {
        return message.toString(); // Convert to string if not already
    }
}